#ifndef __OS_DEP_H
#define __OS_DEP_H

#ifndef XVT_INCL
#include <xvt.h>
#endif

#ifndef __STRINGS_H
#include <strings.h>
#endif

enum os_type { os_Unknown, os_Windows, os_Win32s, os_Windows95, os_Windows98, os_WindowsNT };
os_type os_get_type();

void os_post_menu_event(WINDOW win, MENU_TAG tag);
void os_set_event_hook();

unsigned long os_get_free_memory();      
bool os_is_removable_drive(const char* path);
bool os_is_network_drive(const char* path);
bool os_is_local_drive(const char* path);
bool os_test_disk_free_space(const char* path, unsigned long filesize);
unsigned long os_get_disk_size(const char* path);

COLOR os_choose_color(COLOR col, WINDOW win);
void  os_exec_help_command(MENU_TAG tag, const char* key);
int   os_execute(const TFilename& path, bool sync, bool iconizetask, bool showchild);
bool  os_file_exist(const char* path);

bool os_destroy_native_icon(unsigned icon);
void os_draw_native_icon(WINDOW win, const RCT& rct, unsigned icon);

bool os_allow_another_instance();
bool os_deny_another_instance();

bool os_spawn_by_menu();
void os_wake_up_caller();

void os_iconize_window(WINDOW win);
void os_maximize_window(WINDOW win);
void os_restore_window(WINDOW win);

int  os_get_printer_names(TToken_string& printers);
bool os_set_default_printer(const char* name);
bool os_get_default_printer(TString& name);
bool os_open_spool_row(const char* device);
bool os_spool_row(const char* str);
bool os_close_spool_row();

bool os_get_image_editor_path(TFilename& name);
bool os_dongle_server_running();

#endif
