USE LF_DOC
JOIN LF_RIGHEDOC TO LF_DOC INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN %TIP TO LF_DOC INTO CODTAB==TIPODOC
END

DESCRIPTION
BEGIN
  33->* "Documenti di vendita"
  20->* "Clienti/Fornitori"
  %TIP->* "Tabella tipi documento"
END

GENERAL
BEGIN
  OFFSET 0 0
END

SECTION HEADER ODD 6

STRINGA 1 40 1
BEGIN
 KEY "nome ditta"
 PROMPT  1 1 "Ditta "
 MESSAGE _DITTA, !RAGSOC
END

STRINGA 2 10
BEGIN
 KEY "Data"
 PROMPT  120 1 "Data "
 MESSAGE _TODAY
END

NUMERO 3 7
BEGIN
 KEY "Nr. pagina"
 PROMPT  137 1 "Pagina "
 MESSAGE _PAGENO
END

STRINGA 4 25
BEGIN
 KEY "Intestazione stampa"
 PROMPT  45 2 "Stampa lista documenti"
END

END // HEADER


SECTION BODY ODD 2 COLUMNWISE

STRINGA 11 9
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Cod. num." "Codice numerazione"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Codice numerazione"
 PROMPT  1 1 ""
 FIELD 33->CODNUM
END

STRINGA 12 9
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Tipo doc." "Tipo documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Tipo documento"
 PROMPT  2 1 ""
 FIELD %TIP->S0
END

NUMERO 13 8
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Num.doc." "Numero documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Numero documento"
 PROMPT  3 1 ""
 FIELD 33->NDOC
 PICTURE "#######"
END

DATA 14 10
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Data doc." "Data documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Data documento"
 PROMPT  4 1 ""
 FILED 33->DATADOC
END

NUMERO 15 7
BEGIN
 SPECIAL STRINGA INTESTAZIONE "" "Codice cliente/fornitore"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "X " "Fincatura sinistra e destra"
 KEY "Codice cliente/fornitore"
 PROMPT  5 1 ""
 FIELD 33->CODCF
 PICTURE "#######"
END

STRINGA 16 25 2
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Ragione sociale" "Ragione sociale"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA " X" "Fincatura sinistra e destra"
 KEY "Ragione sociale"
 PROMPT  6 1 ""
 MESSAGE _CLIENTE,!RAGSOC
END

STRINGA 17 5
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Stato" "Stato documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Stato documento"
 PROMPT  7 1 ""
 FIELD 33->STATO
END

STRINGA 18 4
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Val." "Codice valuta"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Cod. Valuta"
 PROMPT 8 1 ""
 FIELD 33->CODVAL
 MESSAGE COPY,10@|_EDITPICTURE,19,20,21,22
END

NUMBER 19 15 
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Tot. Imponibile" "Totale imponibile"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Totale imponibile (con spese)"
 PROMPT  9 1 ""
 MESSAGE _TOTIMPONIBILI,0|COPY,40
 PICTURE "###.###.###.###"
END

NUMBER 20 15 
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CSpese" "Spese"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Spese"
 PROMPT  10 1 ""
 PICTURE "###.###.###.###"
 FIELD TOTSPE
 MESSAGE COPY,41
END

NUMBER 21 15 
BEGIN
 SPECIAL STRINGA INTESTAZIONE "@CIVA" "IVA"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Totale imposte"
 PROMPT  11 1 ""
 FIELD IMPOSTE
 MESSAGE COPY,42
 PICTURE "###.###.###.###"
END

NUMBER 22 15 
BEGIN
 SPECIAL STRINGA INTESTAZIONE "Tot. documento" "Totale documento"
 SPECIAL NUMERO OFFSET "0" "Offset iniziale campo"
 SPECIAL STRINGA FINCATURA "XX" "Fincatura sinistra e destra"
 KEY "Totale documento"
 PROMPT  12 1 ""
 FIELD TOTDOC
 PICTURE "###.###.###.###"
 MESSAGE COPY,43
END

NUMBER 40 15 
BEGIN
 KEY "Hidden field for computing tot imponibili"
 FLAGS "H"
 PROMPT  9 1 ""
 MESSAGE _NUMEXPR,IF(33->CAMBIO!=0;#40*33->CAMBIO;#40)
 MESSAGE ADD,FL->52
END

NUMBER 41 15 
BEGIN
 KEY "Hidden field for computing tot spese"
 PROMPT  10 1 ""
 MESSAGE _NUMEXPR,IF(33->CAMBIO!=0;#41*33->CAMBIO;#41)
 MESSAGE ADD,FL->53
 FLAGS "H"
END

NUMBER 42 15 
BEGIN
 KEY "Hidden field for computing tot imposte"
 PROMPT  11 1 ""
 MESSAGE _NUMEXPR,IF(33->CAMBIO!=0;#42*33->CAMBIO;#42)
 MESSAGE ADD,FL->54
 FLAGS "H"
END

NUMBER 43 15 
BEGIN
 KEY "Hidden field for computing tot documento"
 PROMPT  12 1 ""
 MESSAGE _NUMEXPR,IF(33->CAMBIO!=0;#43*33->CAMBIO;#43)
 MESSAGE ADD,FL->55
 FLAGS "H"
END

SECTION RIGHE 2 0 1 FILE LF_RIGHEDOC
  FLAGS "D"

  STRINGA 1 9
  BEGIN
    PROMPT  1 1 ""
  END

  STRINGA 2 9
  BEGIN
    PROMPT 2 1 ""
  END

  NUMERO 3 8
  BEGIN
    PROMPT 3 1 ""
  END

  DATA 4 10
  BEGIN
    PROMPT 4 1 ""
  END

  NUMERO 5 7
  BEGIN
    PROMPT 5 1 ""
  END

  STRINGA 6 25 
  BEGIN
    PROMPT 6 1 ""
    FIELD LF_RIGHEDOC->DESCR
  END
  
  STRINGA 7 5
  BEGIN
    PROMPT 7 1 ""
    GROUP 10
    FLAGS "H"
    MESSAGE _EDITPICTURE,10,12
  END

  
  STRINGA 8 5
  BEGIN
    PROMPT 7 1 ""
  END

  STRINGA 9 4
  BEGIN
    PROMPT 8 1 ""
    FIELD LF_RIGHEDOC->UMQTA
  END

  NUMBER 10 15 
  BEGIN
    PROMPT 9 1 ""
    FIELD 34->IMPNN
    PICTURE "###.###.###.###"
  END
  
  NUMBER 11 15 
  BEGIN
    PROMPT 10 1 ""
  END

  NUMBER 12 15 
  BEGIN
    PROMPT 11 1 ""
    FIELD LF_RIGHEDOC->IMPOSTA
    PICTURE "###.###.###.###"
  END
END

END //BODY

SECTION FOOTER LAST  3

STRINGA 51 25
BEGIN
 KEY "Totale"
 PROMPT  60 1 "@BTotale"
END

NUMBER 52 15
BEGIN
 KEY "Totale imponibili"
 PROMPT  84 1 ""
 PICTURE "###.###.###.###"
END

NUMBER 53 15 
BEGIN
 KEY "Totale Spese"
 PROMPT  100 1 ""
 PICTURE "###.###.###.###"
END

NUMBER 54 15 
BEGIN
 KEY "Totale imposte"
 PROMPT  116 1 ""
 PICTURE "###.###.###.###"
END

NUMBER 55 15 
BEGIN
 KEY "Totale documenti"
 PROMPT  132 1 ""
 PICTURE "###.###.###.###"
END

END // FOOTER


