USE 33
JOIN 34 INTO CODNUM==CODNUM ANNO==ANNO PROVV==PROVV NDOC==NDOC
JOIN 17 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 20 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF
JOIN 16 TO 33 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 16 TO 17 ALIAS 116 INTO TIPOCF==TIPOCF CODCF==CODCF CODIND==CODINDSP
JOIN 47 INTO CODART==CODART
JOIN %CPG TO 33 ALIAS 201 INTO CODTAB==CODPAG
JOIN 122 TO 33 ALIAS 202 INTO CODAGE==CODAG
JOIN %POR TO 33 ALIAS 203 INTO CODTAB==CODPORTO
JOIN %BAN TO 33 ALIAS 204 INTO CODTAB==CODABIA+CODCABA
JOIN %VET TO 33 ALIAS 205 INTO CODTAB==CODVETT1
JOIN %ABE TO 33 ALIAS 206 INTO CODTAB==ASPBENI1

END
DESCRIPTION
BEGIN
  34->* "Righe documenti di vendita"
  33->* "Documenti di vendita"
  17->* "Clienti/Fornitori per vendite"
  20->* "Clienti/Fornitori"
  16->* "Indirizzi di spedizione (destinazione)"
  116@->* "Indirizzi di spedizione (destinatario)"
  47->* "Anagrafica magazzino"
  201@->* "Tabella condizioni di pagamento"
  202@->* "Tabella agenti"
  203@->* "Tabella porto"
  204@->* "Tabella banche"
  205@->* "Tabella vettori"
  206@->* "Tabella apsetto beni"
END

GENERAL
BEGIN
  OFFSET 0 0
  FONT "Courier New"
  SIZE 12
  MODULE "BUFFETTI_FATTURA_ACCOMPAGNATORIA_01"
  PRI_DECIMALS 0 3
  QTA_DECIMALS 3 3
  IMP_DECIMALS 0 3
  EXCLUDE "08,"
END

SECTION HEADER ODD 27

STRINGA 1 36 1
BEGIN
 KEY "nome ditta"
 PROMPT 5 6 ""
 MESSAGE _DITTA,!RAGSOC
END

STRINGA 2 36 1
BEGIN
 KEY "indirizzo ditta"
 PROMPT 5 7 ""
 MESSAGE _DITTA,!IND
END

STRINGA 3 5 1
BEGIN
 KEY "cap ditta"
 PROMPT 5 8 ""
 MESSAGE _DITTA,!CAP
END

STRINGA 4 30 1
BEGIN
 KEY "comune ditta"
 PROMPT 12 8 ""
 MESSAGE _DITTA,!COM
END

STRINGA 5 5 1
BEGIN
 KEY "scritta p.iva"
 PROMPT 5 9 "P.IVA"
END

STRINGA 6 16 1
BEGIN
 KEY "partita iva ditta"
 PROMPT 11 9 ""
 MESSAGE _DITTA,!IVA
END

STRINGA 7 9 1
BEGIN
 KEY "scritta cod.fisc."
 PROMPT 5 10 "COD.FISC"
END

STRINGA 8 16 1
BEGIN
 KEY "codice fiscale ditta"
 PROMPT 15 10 ""
 MESSAGE _DITTA,!CF
END

NUMERO 9 30 1
BEGIN
 KEY "reg.soc.trib...."
 PROMPT  5 11 "REG.SOC.TRIB.R.E.  "
 MESSAGE _DITTA,!REGSOC
 FLAGS "D"
END

NUMERO 10 30 1 
BEGIN
 KEY "c.c.i.a.a. 143011"
 PROMPT 5 12 "C.C.I.A.A.         "
 MESSAGE _DITTA,!CCIAA
 FLAGS "D"
 END

STRINGA 11 37 2
BEGIN
 KEY "Cliente ,rag.soc"
 PROMPT 44 7 ""
 MESSAGE _CLIENTE,!RAGSOC
END

STRINGA 12 37 1
BEGIN
 KEY "Cliente, indirizzo"
 PROMPT 44 9 ""
 MESSAGE _CLIENTE,!INDNUM
END

STRINGA 13 37 1
BEGIN
 KEY "cliente localita"
 PROMPT  44 10 ""
 MESSAGE _CLIENTE,LOCALITACF
END

STRINGA 14 5 1
BEGIN
 KEY "Cliente, cap"
 PROMPT 44 11 ""
 MESSAGE _CLIENTE,!CAP
END

STRINGA 15 30 2
BEGIN
 KEY "Cliente, comune"
 PROMPT 50 11 ""
 MESSAGE _CLIENTE,!COM->DENCOM
END

STRINGA 16 2 1
BEGIN
 KEY "Cliente, provincia"
 PROMPT 77 12 ""
 MESSAGE _CLIENTE,!COM->PROVCOM
END

STRING 17 37 2
BEGIN
 KEY "destinazione, rag.soc."
 PROMPT 44 14 ""
 FIELD 16->RAGSOC
END

STRINGA 18 37 1
BEGIN
 KEY "destinazione, indirizzo"
 PROMPT 44 16 ""
 FIELD 16->INDIR
END

STRINGA 19 35 1
BEGIN
 KEY "destinazione localita"
 PROMPT  44 17 ""
 FIELD 16->LOCALITA
END

STRINGA 20 5 1
BEGIN
 KEY "destinazione, cap"
 PROMPT 44 18 ""
 FIELD 16->CAP
END

STRINGA 21 50 1
BEGIN
 FLAGS "H"
 PROMPT 1 1 ""
 FIELD 16->COM
END

STRINGA 22 30 2
BEGIN
 KEY "destinazione, comune"
 PROMPT 50 18 ""
 MESSAGE _ISAMREAD,13,COM=#21,DENCOM
END

STRINGA 23 2 1
BEGIN
 KEY "destinazione, provincia"
 PROMPT 77 19 ""
 MESSAGE _ISAMREAD,13,COM=#21,PROVCOM
END

STRINGA 24 3 1
BEGIN
 KEY "codice agente"
 PROMPT 4 25 ""
 FIELD CODAG
END

STRINGA 25 7 1
BEGIN
 KEY "codice cliente"
 PROMPT 8 25 ""
 FIELD CODCF
END

STRINGA 26 11 1
BEGIN
 KEY "partita iva cliente"
 PROMPT 19 25 ""
 MESSAGE _CLIENTE,PIVA
END

STRINGA 27 16 1
BEGIN
 KEY "codice fiscale cliente"
 PROMPT 31 25 ""
 MESSAGE _CLIENTE,COFI
END

DATA 28 8 1
BEGIN
 KEY "data documento"
 PROMPT 60 21 ""
 FIELD DATADOC
 FORMAT "1442-"
END

STRINGA 29 7
BEGIN
 KEY "numero documento"
 PROMPT 71 21 ""
 FIELD 33->NDOC
END

STRINGA 30 2
BEGIN
 KEY "Numero di pagina"
 PROMPT  81 21 ""
 MESSAGE _PAGENO
END

STRINGA 31 48 1
BEGIN
 KEY "condizioni di pagamento"
 PROMPT 4 23 ""
 FIELD 201@->S0
END

STRINGA 32 28 1
BEGIN
 KEY "banca d'appoggio"
 PROMPT 54 23 ""
 FIELD 204@->S0
END

NUMERO 33 7 1
BEGIN
 KEY "ordine"
 PROMPT  4 21 ""
 FIELD 33->NUMDOCRIF
END

DATA 34 10 1
BEGIN
 KEY "data conferma"
 PROMPT  26 21 ""
 FIELD 33->DATADOCRIF
 FORMAT "1444-"
END

END

SECTION BODY ODD 5

STRINGA 51 12 1
BEGIN
 KEY "codice articolo"
 PROMPT 3 1 ""
 FIELD 34->CODART
END

STRINGA 52 18 20
BEGIN
 KEY "descrizione articolo"
 PROMPT 16 1 ""
 MESSAGE _DESCRIGA
END

STRINGA 53 2
BEGIN
 KEY "unita' di misura"
 PROMPT 36 1 ""
 FIELD 34->UMQTA
 MESSAGE _ALIGN,#52,BOTTOM
END

NUMBER 54 12
BEGIN
 KEY "quantita'"
 PROMPT 40 1 ""
 PICTURE "###.###.###"
 GROUP 30
 FIELD 34->QTA
 MESSAGE _ALIGN,#52,BOTTOM
END

NUMBER 55 8
BEGIN
 KEY "prezzo unitario"
 PROMPT 57 1 ""
 PICTURE "########"
 GROUP 29
 FIELD 34->PREZZO
 MESSAGE _ALIGN,#52,BOTTOM
END

STRINGA 56 3
BEGIN
 KEY "sconto"
 PROMPT 66 1 ""
 FIELD 34->SCONTO
 MESSAGE _ALIGN,#52,BOTTOM 
END

NUMBER 57 9
BEGIN
 KEY "importo netto"
 PROMPT  70 1 ""
 GROUP 29
 FIELD 34->IMPNS
 PICTURE "#.###.###"
 MESSAGE _ALIGN,#52,BOTTOM
END

STRINGA 58 2 1
BEGIN
 KEY "iva"
 PROMPT 80 1 ""
 FIELD 34->CODIVA
 MESSAGE _ALIGN,#52,BOTTOM
END

NUMBER 59 15
BEGIN
 KEY "prezzo unitario scontato"
 PROMPT  68 1 ""
 PICTURE "###.###.###.###"
 GROUP 29
 FIELD 34->PREZZONS
 MESSAGE _ALIGN,#52,BOTTOM
 FLAGS "H"
END

NUMBER 60 15
BEGIN
 KEY "provvigione"
 PROMPT  68 1 ""
 PICTURE "###.###.###.###"
 MESSAGE _ALIGN,#52,BOTTOM
 FIELD 34->PROVVR
 GROUP 31
 FLAGS "H"
END

NUMBER 61 15
BEGIN
 KEY "Imposta"
 PROMPT  68 1 ""
 PICTURE "###.###.###.###"
 MESSAGE _ALIGN,#52,BOTTOM
 FIELD 34->IMPOSTA
 GROUP 31
 FLAGS "H"
END

END

SECTION FOOTER ODD -46

STRINGA 81 5 1
BEGIN
 KEY "messaggio 'segue' in coda"
 PROMPT 70 12 "SEGUE"
END

END

SECTION FOOTER LAST -46

NUMBER 101 12 
BEGIN
 KEY "totale importi netti (non scontati)"
 PROMPT  4 3 ""
 FIELD TOTMER
 PICTURE "###.###.###"
 GROUP 31
END

STRING 102 6 
BEGIN
 KEY "sconto %"
 PROMPT 20 3 ""
 FIELD 33->SCONTOPERC
END

NUMBER 103 12 
BEGIN
 KEY "totale sconto testa"
 PROMPT  28 3 ""
 FIELD SCONTOT
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 104 12
BEGIN
 KEY "spese di trasporto"
 PROMPT 42 3 ""
 FIELD SPESTRA
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 105 12
BEGIN
 KEY "spese di imballo"
 PROMPT 56 3 ""
 FIELD SPESIMB
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 106 12
BEGIN
 KEY "Totale spese"
 PROMPT 70 3 ""
 FIELD SPESE
 PICTURE "###.###.###"
 GROUP 31
END

STRING 107 2 
BEGIN
 KEY "codice iva 1"
 PROMPT  3 5 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

NUMBER 108 12 
BEGIN
 KEY "imponibile 1"
 PROMPT  6 5 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 109 2 
BEGIN
 KEY "iva 1"
 PROMPT  19 5 ""
 MESSAGE _RIEPILOGOIVA,1,ALI,0
 PICTURE "##"
END

NUMBER 110 10 
BEGIN
 KEY "imposta 1"
 PROMPT  22 5 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 PICTURE "##.###.###"
 GROUP 31
END

STRING 111 2 
BEGIN
 KEY "codice iva 2"
 PROMPT  3 6 ""
 MESSAGE _RIEPILOGOIVA,1,COD,0
END

NUMBER 112 12 
BEGIN
 KEY "imponibile 2"
 PROMPT  6 6 ""
 MESSAGE _RIEPILOGOIVA,1,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 113 2 
BEGIN
 KEY "iva 2"
 PROMPT  19 6 ""
 MESSAGE _RIEPILOGOIVA,1,ALI,0
 PICTURE "##"
END

NUMBER 114 10 
BEGIN
 KEY "imposta 2"
 PROMPT  22 6 ""
 MESSAGE _RIEPILOGOIVA,1,IVA,1
 PICTURE "##.###.###"
 GROUP 31
END

STRING 115 2 
BEGIN
 KEY "codice iva 3"
 PROMPT  3 7 ""
 MESSAGE _RIEPILOGOIVA,30,COD,0
END

NUMBER 116 12 
BEGIN
 KEY "imponibile 3"
 PROMPT  6 7 ""
 MESSAGE _RIEPILOGOIVA,30,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

STRINGA 117 45 
BEGIN
 KEY "descrizione altri 3"
 PROMPT  35 7 ""
 MESSAGE _RIEPILOGOIVA,30,DES,1
END

STRING 118 2 
BEGIN
 KEY "codice iva 4"
 PROMPT  3 8 ""
 MESSAGE _RIEPILOGOIVA,30,COD,0
END

NUMBER 119 12
BEGIN
 KEY "imponibile 4"
 PROMPT  6 8 ""
 MESSAGE _RIEPILOGOIVA,30,IMP,0
 PICTURE "###.###.###"
 GROUP 31
END

STRINGA 120 45 
BEGIN
 KEY "descrizione altri 4"
 PROMPT  35 8 ""
 MESSAGE _RIEPILOGOIVA,30,DES,1
END

NUMBER 121 15 
BEGIN
 KEY "totale imponibile"
 PROMPT  3 10 ""
 MESSAGE _TOTIMPONIBILI,29
 PICTURE "##.###.###.###"
 GROUP 31
END

NUMBER 122 14 
BEGIN
 KEY "totale imposta"
 PROMPT  19 10 ""
 FIELD IMPOSTE
 PICTURE "#.###.###.###"
 GROUP 31
END

NUMBER 123 10 
BEGIN
 KEY "totale esenti"
 PROMPT  35 10 ""
 MESSAGE _TOTIMPONIBILI,28
 PICTURE "##.###.###"
 GROUP 31
END

NUMBER 124 8
BEGIN
 KEY "spese di incasso"
 PROMPT 54 10 ""
 FIELD SPESINC
 PICTURE "###.###"
 GROUP 31
END

NUMBER 125 5
BEGIN
 KEY "spese bolli"
 PROMPT 63 10 ""
 FIELD BOLLI
 PICTURE "#####"
 GROUP 31
END

NUMBER 126 12 
BEGIN
 KEY "totale fattura"
 PROMPT  70 10 ""
 FIELD TOTDOC
 PICTURE "###.###.###"
 GROUP 31
END

DATA 127 8 
BEGIN
 KEY "scadenza pagamento 1"
 PROMPT  3 14 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 128 11 
BEGIN
 KEY "importo scadenza 1"
 PROMPT  12 14 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 129 8 
BEGIN
 KEY "scadenza pagamento 2"
 PROMPT  25 14 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 130 11
BEGIN
 KEY "importo scadenza 2"
 PROMPT  34 14 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END
        
DATA 131 8 
BEGIN
 KEY "scadenza pagamento 3"
 PROMPT  47 14 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 132 11 
BEGIN
 KEY "importo scadenza 3"
 PROMPT  56 14 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 133 8 
BEGIN
 KEY "scadenza pagamento 4"
 PROMPT  3 15 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 134 11 
BEGIN
 KEY "importo scadenza 4"
 PROMPT  12 15 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

DATA 135 8 
BEGIN
 KEY "scadenza pagamento 5"
 PROMPT  25 15 ""
 MESSAGE _SCADENZE,DATA,0
 FORMAT "1442-"
END

NUMBER 136 11 
BEGIN
 KEY "importo scadenza 5"
 PROMPT  34 15 ""
 MESSAGE _SCADENZE,IMPORTO,1
 PICTURE "###.###.###"
 GROUP 31
END

NUMBER 137 12 
BEGIN
 KEY "netto a pagare"
 PROMPT  70 15 ""
 FIELD TOTDOC
 PICTURE "###.###.###"
 GROUP 31
END

LIST 138 1 1
BEGIN
 KEY "trasporto a cura del mitt."
 PROMPT 4 17 ""
 FIELD CODSPMEZZO
 ITEM "|" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "D| "
 ITEM "M|X" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "V| "
END

LIST 139 1 1
BEGIN
 KEY "trasporto a cura del dest."
 PROMPT 7 14 ""
 FIELD CODSPMEZZO
 ITEM "|" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "D|X" MESSAGE DISABLE,6@|ENABLE,5@
 ITEM "M| "
 ITEM "V| "
END

LIST 140 1 1
BEGIN
 KEY "trasporto a cura del vett."
 PROMPT 25 25 ""
 FIELD CODSPMEZZO
 ITEM "|" // default
 ITEM "D| "
 ITEM "M| "
 ITEM "V|X" MESSAGE DISABLE,5@|ENABLE,6@
END

STRING 141 19 1
BEGIN
 KEY "aspetto beni"
 PROMPT 32 17 ""
 FIELD 206@->S0
END

STRING 142 5 1
BEGIN
 KEY "colli"
 PROMPT 52 17 ""
 FIELD NCOLLI
END

STRING 143 7 1
BEGIN
 KEY "peso"
 PROMPT 60 17 ""
 FIELD PNETTO
END

STRING 144 35 1
BEGIN
 KEY "nome vettore"
 PROMPT 3 19 ""
 FIELD 205@->S0
END

STRING 145 35 1
BEGIN
 KEY "indirizzo vettore"
 PROMPT 3 20 ""
 FIELD 205@->S1[1,35]
END

STRING 146 45 1
BEGIN
 KEY "localita' vettore"
 PROMPT 3 21 ""
 FIELD 205@->S1[46,70]
 FLAGS "D"
END

STRING 147 5 1
BEGIN
 KEY "CAP vettore"
 PROMPT 3 21 ""
 FIELD 205@->S7
END

STRING 148 5 1
BEGIN
 KEY "Codice comune vettore"
 PROMPT 1 1 ""
 FIELD 205@->S9
 FLAGS "H"
END

STRING 149 25 1
BEGIN
 KEY "Denominazione comune vettore"
 PROMPT 9 21 ""
 MESSAGE _ISAMREAD,13,COM=#148,DENCOM
END

STRING 150 2 1
BEGIN
 KEY "Provincia comune vettore"
 PROMPT 37 21 ""
 MESSAGE _ISAMREAD,13,COM=#148,PROVCOM
END

DATA 151 8 
BEGIN
 KEY "data inizio trasporto"
 PROMPT 40 19 ""
 FIELD DATAPART
 FORMAT "1442-"
END

STRING 152 5 1
BEGIN
 KEY "ora inizio trasporto"
 PROMPT 49 19 ""
 PICTURE "## ##"
 FIELD ORAPART
END

END

END


//   NOTE SULLA COMPILAZIONE DEI FORM DI STAMPA
//
//   SEZIONE GENERAL
//   ===============
//   Posizionamento:
//    e' possibile effettuari posizionamenti manuali dei form con le seguenti istruzioni:
//    CARATTERE <S> 
//    INIZIALE  <N> <N>
//    FINALE    <N> <N>
//   dove:
//      CARATTERE indica il carattere da stampare per contrassegnare il posizionamento, racchiuso tra doppi apici (eg "X")
//      INIZIALE  indica le coordinate X ed Y per il posizionamento iniziale (dove stampare il primo carattere)
//      FINALE    indica le coordinate X ed Y per il posizionamento finale (dove stampare il secondo carattere)
//   FINALE puo' essere omesso; se definito e' comunque buona norma tenere la coordinata verticale (Y) uguale
//   a quella indicata in INIZIALE, se diversi il programma tiene conto solo della prima.
//   Non e' possibile definire sia posizionamenti manuali che OFFSET, quindi o l'uno o l'altro, preferibilmente
//   e' meglio scegliere OFFSET.
//
//   Modificatori di pictures:
//   i parametri IMP_DECIMALS, QTA_DECIMALS, e PRI_DECIMALS settano i decimali da stampare/arrotondare
//   per i seguenti: importi in genere, quantita', e prezzi. Il primo parametro intero e' per gli importi in lire
//   il secondo per gli importi in valuta. Naturalmente per le quantita' non ha senso fare una cosa del genere, ma per completezza
//   e' stata implementata.
//   PRI_DECIMALS corrisponde al gruppo 29
//   QTA_DECIMALS corrisponde al gruppo 30
//   IMP_DECIMALS corrisponde al gruppo 31
//   pertanto tutti i campi che apparterranno al gruppo 29,30 o 31 avranno gli importi stampati al numero di decimali impostati a
//   seconda se il documento e' in lire o valuta. Se il numero di decimali e' 0 la picture rimarra' invariata.
//   Altri gruppi definiti dall'utente saranno cosi' sintatticamente impostati:
//   NEW_GROUP <n> <lit_dec> <val_dec>
//   Dove <n> e' il numero del gruppo
//        <lit_dec> e' il numero di decimali per i documenti in lire
//        <val_dec> e' il numero di decimali per i documenti in valuta
//   
//   Definizione di liste di esclusione (facoltativo):
//   EXCLUDE esclude dalla stampa le righe che soddisfano la condizione specificata.
//   Si indicano in questo modo: "<tipo riga>,<cod. art>". Naturalmente si possono indicare tutti gli EXLCUDE che si vogliono.
//   Es: EXCLUDE "V01,ART1" escludera' tutte le righe di tipo V01 con codice articolo ART1
//       EXCLUDE ",ART1" escludera' tutte le righe che hanno codice articolo ART1
//       EXCLUDE "V01," escludera' tutte le righe che hanno tipo riga V01
//       EXCLUDE "," non escludera' nulla.
//
//  MESSAGGI UTENTE
//  ===============
//  Note sui messaggi della testata/body/footer:
//
//  _ISAMREAD:
//    lettura generica di un file del database
//    sintassi: _ISAMREAD,<file>,<espressione input>[!<espressione input>!...],{<campo file>|<espressione output>[!<espressione output>!...]}
//    dove: <file>  il numero logico del file o il nome della tabella
//       <espressione input>  un'espressione del tipo <campo file>=<espressione campi form>
//       <espressione campi form>  un'espressione di costanti numeriche, stringhe e valori di campi della form (indicati con il loro numero preceduto da #)
//       <espressione output>  un'espressione del tipo <campo form o gruppo>=<campo file> (se  un gruppo deve essere seguito da @) oppure solo <campo file> (il campo della form  quello corrente)
//  
//  _TABLEREAD:
//    lettura generica di un campo di una tabella
//    sintassi: _TABLEREAD,<tabella>,<chiave>,<campo file>
//    dove: <tabella> nome tabella da leggere
//       <chiave> costante stringa o riferimento a campo della form (preceduto da '#') da usare come chiave di ricerca
//       <campo file> identificativo del campo da leggere dalla tabella
//
//  _DITTA:
//    lettura dei dati della ditta
//    sintassi: _DITTA,{<campo relazione>|<macro>}
//    dove: <campo relazione>  un riferimento alla relazione di gestione dei dati della ditta (es. 113@->DENCOM  la denominazione del comune di residenza della ditta)
//         <macro>  uno delle macro seguenti:
//         !RAGSOC  ragione sociale
//         !CAP     Codice Avviamento Postale (viene implementato un messaggio perche' sugli occasionali ha un nome campo diverso!!)
//         !IND     indirizzo (fiscale se c', oppure di residenza)
//         !NUM     numero civico (fiscale se c', oppure di residenza)
//         !CAP     CAP (fiscale se c', oppure di residenza)
//         !COM     comune (fiscale se c', oppure di residenza)
//         !PROV    provincia (fiscale se c', oppure di residenza)
//         !IVA     partita iva
//         !CF      codice fiscale
//         !TEL     numero di telefono (con prefisso)
//         !FAX     numero di fax (con prefisso)
//         !REGSOC  numero di registrazione presso il Tribunale
//         !CCIAA   numero di registrazione presso la camera di commercio
//    nota: la relazione della ditta  cos strutturata:
//       %NDITTE (9) Dati ditte
//       + %ANAGR (6) Anagrafica generale (indirizzo, ecc.)
//          + %COMUNI (113@) Comune di residenza
//          + %COMUNI (213@) Comune di residenza fiscale
//    viene utilizzato perche' non e' possibile stabilire altrimenti una relazione con il file ditte
//    dall'interno del form.
//
//  _CLIENTE
//    lettura dei dati del cliente
//    sintassi: _CLIENTE,{<campo relazione>|<macro>}
//    dove: <campo relazione>  un riferimento alla relazione di gestione dei dati del cliente
//         <macro>  uno delle macro seguenti:
//         !RAGSOC  ragione sociale
//         !IND     indirizzo
//         !NUM     numero civico
//         !INDNUM  indirizzo + numero civico
//         !TEL     primo numero di telefono (con prefisso)
//         !TEL2    secondo numero di telefono (con prefisso)
//         !TEL3    terzo numero di telefono (con prefisso)
//         !FAX     numero di fax (con prefisso)
//         !COM-><FIELD>  accede ai campi del comune di residenza cliente
//         !COMN-><FIELD> accede ai campi del comune di nascita del cliente
//    nota: la relazione del cliente  cos strutturata:
//       CLIFO (20) Clienti/fornitori
//       + CFVEN (17) Clienti/fornitori per vendite
//       + %COMUNI (113@) Comune di residenza
//       + %COMUNI (213@) Comune di nascita
//    viene utilizzato al posto del file 17 collegato perche' vi sono particolari
//    accorgimenti per quanto riguarda i clienti occasionali.
// 
//  _DESCRIGA:
//    Messaggio per reperire e formattare anche la descrizione estesa sulle righe del documento
//
//  _ALIGN:
//    allineamento della posizione di un campo rispetto ad un altro
//    sintassi: _ALIGN,<campo form>[,<allineamento>][,<allineamento>...]
//    dove: <campo form>  il campo della form (preceduto da '#') da cui prendere l'allineamento
//       <allineamento>  uno dei seguenti valori:
//        TOP    allinea sulla riga d'inizio
//        MIDDLE allinea al centro (effettivo)
//        BOTTOM allinea sulla riga di fine (effettiva, non preimpostata)
//        LEFT   allinea sulla colonna d'inizio
//        RIGHT  allinea sulla colonna di fine
//
//  _PAGENO:
//    Messaggio per stampare il numero di pagina corrente
//
//  _RIEPILOGOIVA:
//    messaggio per stampare la tabella ripelogativa delle aliquote IVA e relative imposte
//    sintassi: _RIEPILOGOIVA,<selettore>,<macro>,<cambio codice>
//    dove: <selettore>  uno dei seguenti:
//        1 = codici IVA a regime normale
//        2 = codici IVA da ventilare
//        4 = codici IVA esenti
//        8 = codici IVA non imponibili
//       16 = codici IVA non soggetti
//       oppure la combinazione di uno o piu' di essi:
//       12 = 4+8, 19 = 1+2+16, 29 = 1+4+8+16 ecc...
//       pertanto per avere i non imponibili in totale il selettore sara' 1,
//       per avere gli esenti il selettore sara' 4; per avere i non soggetti + esenti
//       il selettore sara' 20  e cosi' via.
//    dove: <macro>  uno dei seguenti:
//        COD     colonna dei codici
//        IMP     colonna degli imponibili
//        IVA     colonna delle imposte
//        ALI     colonna delle aliquote
//        DES     colonna delle descrizioni (stampata solo se il regime IVA non e' normale)
//    dove: <cambio codice>  uno dei seguenti:
//        0        indica di non leggere il successivo codice IVA nella tabella riepilogativa
//        1        indica di leggere il successivo codice IVA nella tabella riepilogativa
//
//  _TOTIMPONIBILI:
//    messaggio per stampare diverse totalizzazioni di imponibili
//    sintassi: _TOTIMPONIBILI,<selettore>
//    dove: <selettore> funge da filtro per la somma degli imponibili
//    vedi _RIEPILOGOIVA per la spiegazione dei filtri selettivi
//
//  _SCADENZE:
//    messaggio per stampare le scadenze
//    sintassi: _SCADENZE,<macro>,<cambio codice>
//    dove <macro> e' uno dei seguenti:
//      DATA    : stampa la data di scadenza 
//      IMPORTO : stampa l'importo in scadenza
//    dove <cambio codice> vale 0 o 1 se indica di rendere corrente la prossima scadenza
//
//  CAMPI VIRTUALI
//  ==============
//  Oltre a stampare i campi normali del file e' anche possibile stampare i campi virtuali
//  definiti nei profili semplicemente indicandoli nella istruzione FIELD:
//  per la testata del documento:
//  BOLLI, BASESCONTO, IMPOSTE, PROVVD, SCONTOD, SPESEINC, TOTDOC, TOTMER, TOTNS, TOTPRE, TOTSPE
//  per le righe:
//  IMPLN, IMPLS, IMPNN, IMPNS, IMPOSTA, PREZZOLN, PREZZOLS, PREZZONN, PREZZONS, PROVVR, SCONTOR
//  oltre, naturalmente a quelli definiti dall'utente

